<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Admin\Api;

use PhalApi\Api;
use PhalApi\Exception\BadRequestException;

/**
 * 二维码模块
 */
class QrCode extends Api {

    public function getRules() {
        return array(
            '*' => array(
                'level' => array('name' => 'level', 'type' => 'enum', 'range' => array('L','M','Q','H'), 'default' => 'H', 'desc' => '错误纠正级别，L为最小，H为最佳'),
                'size' => array('name' => 'size', 'type' => 'int', 'min' => 1, 'max' => 10, 'default' => 6, 'desc' => '二维码尺寸大小'),
                'isShowPic' => array('name' => 'output', 'type' => 'boolean', 'default' => true, 'desc' => '是否直接显示二维码，否的话通过base64返回二维码数据'),
                'accessToken' => array('name' => 'access_token', 'is_doc_hide' => true),
            ),
            'png' => array(
                'data' => array('name' => 'data', 'require' => true, 'desc' => '待生成二维码的内容'),
            ),
            'phoneNumber' => array(
                'phoneNumber' => array('name' => 'phone_number', 'require' => true, 'desc' => '电话号码或手机号，可用于扫码后直接拨打'),
            ),
            'sms' => array(
                'phoneNumber' => array('name' => 'phone_number', 'require' => true, 'desc' => '手机号，接收短信的手机号'),
            ),
            'mailto' => array(
                'email' => array('name' => 'email', 'require' => true, 'desc' => '邮箱地址'),
            ),
            'card' => array(
                'name' => array('name' => 'name', 'require' => true, 'desc' => '姓名'),
                'phone' => array('name' => 'phone', 'desc' => '工作电话，不提供不显示'),
                'phonePrivate' => array('name' => 'phone_private', 'desc' => '家庭电话，不提供不显示'),
                'phoneCell' => array('name' => 'phone_cell', 'desc' => '移动电话，不提供不显示'),
                'email' => array('name' => 'email', 'desc' => '邮箱地址，不提供不显示'),
                'address' => array('name' => 'address', 'desc' => '工作地址，不提供不显示'),
                'orgName' => array('name' => 'org_name', 'desc' => '组织名称，不提供不显示'),
            ),
            'decode' => array(
                'file' => array('name' => 'file', 'source' => 'post', 'desc' => '（二选一）二维码图片的base64编码。格式示例：data:image/gif;base64,R0lGODlhAQABAIAAAHd3dwAAACH5BAAAAAAALAAAAAABAAEAAAICRAEAOw=='),
                'url' => array('name' => 'img_url', 'desc' => '（二选一）二维码图片链接', 'regx' => '/\b(?:(?:https?|ftp):\/\/|www\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i'),
            ),
            'logo' => array(
                'file' => array('name' => 'file', 'source' => 'post', 'desc' => '（二选一）二维码图片的base64编码。格式示例：data:image/gif;base64,R0lGODlhAQABAIAAAHd3dwAAACH5BAAAAAAALAAAAAABAAEAAAICRAEAOw=='),
                'url' => array('name' => 'logo_url', 'desc' => '（二选一）二维码图片链接', 'regx' => '/\b(?:(?:https?|ftp):\/\/|www\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i'),
                'data' => array('name' => 'data', 'require' => true, 'desc' => '待生成二维码的内容'),
            )
        );
    }

    /**
     * 根据文本内容，生成二维码
     * @desc 可根据传入的文本内容，生成对应的二维码，还可以调整尺寸大小。可以直接输出png图片，也可以返回base64后的图片数据。
     */
    public function png() {
        $qrcode = \PhalApi\DI()->get('qrcode', new \PhalApi\QrCode\Lite());

        if ($this->isShowPic) {
            $qrcode->png($this->data, false, $this->level, $this->size);
            exit();
        } else {
            $temp = tempnam("/tmp", 'qrcode');
            $qrcode->png($this->data, $temp, $this->level, $this->size);
            return base64_encode(file_get_contents($temp));
        }
    }


    /**
     * 生成电话号码二维码
     * @desc 根据电话号码生成二维码，生成后手机扫码后可直接进入电话拨打。
     */
    public function phoneNumber() {
        $this->data = 'tel:'.$this->phoneNumber;
        return $this->png();
    }

    /**
     * 生成发短信二维码
     * @desc 根据手机号生成二维码，生成后手机扫码后可直接进入短信编辑发送界面
     */
    public function sms() {
        $this->data = 'sms:'.$this->phoneNumber;
        return $this->png();
    }

    /**
     * 生成发邮件二维码
     * @desc 根据邮箱地址，生成后手机扫码后可直接进入邮件发送界面
     */
    public function mailto() {
        $this->data = 'mailto:'.$this->email;
        return $this->png();
    }

    /**
     * 生成名片二维码
     * @desc 生成名版二维码，支持名字、手机号、联系电话、邮箱、工作地址、组织等
     */
    public function card() {

        // here our data
        $name         = $this->name;
        $phone        = $this->phone;
        $phonePrivate = $this->phonePrivate;
        $phoneCell    = $this->phoneCell;
        $orgName      = $this->orgName;

        $email        = $this->email;

        // if not used - leave blank!
        $addressLabel     = 'Our Office';
        $address = $this->address;

        // we building raw data
        $codeContents  = 'BEGIN:VCARD'."\n";
        $codeContents .= 'VERSION:2.1'."\n";
        $codeContents .= 'FN:'.$name."\n";
        if ($orgName !== null) {
            $codeContents .= 'ORG:'.$orgName."\n";
        }

        if ($phone !== null) {
            $codeContents .= 'TEL;WORK;VOICE:'.$phone."\n";
        }
        if ($phonePrivate !== null) {
            $codeContents .= 'TEL;HOME;VOICE:'.$phonePrivate."\n";
        }
        if ($phoneCell !== null) {
            $codeContents .= 'TEL;TYPE=cell:'.$phoneCell."\n";
        }

        if ($address !== null) {
            $codeContents .= 'ADR;TYPE=work;'.
                'LABEL="'.$addressLabel.'":'
                .$address
                ."\n";
        }

        if ($email !== null) {
            $codeContents .= 'EMAIL:'.$email."\n";
        }

        $codeContents .= 'END:VCARD';

        $this->data = $codeContents;
        return $this->png();
    }

    /**
     * 生成带logo的二维码
     * @desc 生成带logo的二维码
     */
    public function logo(){
        ini_set('memory_limit', '256M');
        $logo = '/tmp/' . md5(date('YmdHis') . rand(0, 999999));
        if (!empty($this->file)) {
            if (!preg_match('/^(data:\s*image\/(\w+);base64,)/', $this->file, $matches)) {
                throw new BadRequestException(\PhalApi\T("the uploaded picture is in the wrong format and cannot be recognized, correct example:{example}",
                  array('example' => 'data:image/gif;base64,R0lGODlhAQABAIAAAHd3dwAAACH5BAAAAAAALAAAAAABAAEAAAICRAEAOw==')
                ));
            }
            $putRs = file_put_contents($logo, base64_decode(str_replace($matches[1], '', $this->file)));
            if (!$putRs) {
                throw new BadRequestException(\PhalApi\T("image upload failed, please try again"));
            }
        } else if (!empty($this->url)) {
            $content = file_get_contents($this->url);
            file_put_contents($logo, $content);

        }
        $temp = tempnam("/tmp", 'qrcode');  //已经生成的原始二维码图
        \PhalApi\DI()->qrcode->png($this->data, $temp, $this->level, $this->size);  //生成二维码图片
        $QR = imagecreatefromstring(file_get_contents($temp));
        $logo = imagecreatefromstring(file_get_contents($logo));
        $QR_width = imagesx($QR);       //二维码图片宽度
        $QR_height = imagesy($QR);      //二维码图片高度
        $logo_width = imagesx($logo);   //logo图片宽度
        $logo_height = imagesy($logo);  //logo图片高度
        $logo_qr_width = $QR_width / 5; //logo图片在二维码图片中宽度大小
        $scale = $logo_width/$logo_qr_width;
        $logo_qr_height = $logo_height/$scale; //logo图片在二维码图片中高度大小
        $from_width = ($QR_width - $logo_qr_width) / 2;
        //重新组合图片并调整大小
        imagecopyresampled($QR, $logo, $from_width, $from_width, 0, 0, $logo_qr_width,
            $logo_qr_height, $logo_width, $logo_height);
        if ($this->isShowPic) {
            // 允许跨域
            header('Access-Control-Allow-Origin: *');
            header('Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept, X-Xsrf-Token');
            header('Access-Control-Allow-Methods: GET, POST, DELETE, PUT, OPTIONS');
            header('Access-Control-Allow-Credentials: true');
            header('Content-Type:image/png');
            imagepng($QR);
            exit();
        }
        $rs = array('qrcode' => '');
        $final  = tempnam("/tmp", 'qrcodelogo');
        imagepng($QR, $final);
        $rs['qrcode'] = base64_encode(file_get_contents($final));

        return $rs;

    }
}
